Index: c/src/ada-tests/tmtests/tm18/tmtest.adb
===================================================================
--- c/src/ada-tests/tmtests/tm18/tmtest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/tmtests/tm18/tmtest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,154 @@
+--
+--  TMTEST / BODY
+--
+--  DESCRIPTION:
+--
+--  This package is the implementation of Test 18 of the RTEMS
+--  Timing Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  tmtest.adb,v 1.3 1995/07/12 19:43:58 joel Exp
+--
+
+with INTERFACES; use INTERFACES;
+with RTEMS;
+with RTEMS_CALLING_OVERHEAD;
+with TEST_SUPPORT;
+with TEXT_IO;
+with TIME_TEST_SUPPORT;
+with UNSIGNED32_IO;
+
+package body TMTEST is
+
+--PAGE
+-- 
+--  INIT
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS     : RTEMS.STATUS_CODES;
+   begin
+
+      TEXT_IO.NEW_LINE( 2 );
+      TEXT_IO.PUT_LINE( "*** TIME TEST 18 ***" );
+
+      TMTEST.TEST_INIT;
+
+      RTEMS.TASK_DELETE( RTEMS.SELF, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_DELETE OF SELF" );
+
+   end INIT;
+
+--PAGE
+-- 
+--  TEST_INIT
+--
+
+   procedure TEST_INIT
+   is
+      ID         : RTEMS.ID;
+      TASK_ENTRY : RTEMS.TASK_ENTRY_POINT;
+      INDEX      : RTEMS.UNSIGNED32;
+      STATUS     : RTEMS.STATUS_CODES;
+   begin
+
+      for INDEX in 0 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+      loop
+
+         RTEMS.TASK_CREATE( 
+            RTEMS.BUILD_NAME( 'T', 'I', 'M', 'E' ),
+            128,
+            1024, 
+            RTEMS.DEFAULT_MODES,
+            RTEMS.DEFAULT_ATTRIBUTES,
+            ID,
+            STATUS
+         );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE LOOP" );
+
+
+         if INDEX = TIME_TEST_SUPPORT.OPERATION_COUNT then
+            TASK_ENTRY := TMTEST.LAST_TASK'ACCESS;
+         elsif INDEX = 0 then
+            TASK_ENTRY := TMTEST.FIRST_TASK'ACCESS;
+         else
+            TASK_ENTRY := TMTEST.MIDDLE_TASKS'ACCESS;
+         end if;
+
+         RTEMS.TASK_START( ID, TASK_ENTRY, 0, STATUS );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START LOOP" );
+
+      end loop;
+
+   end TEST_INIT;
+
+--PAGE
+-- 
+--  FIRST_TASK
+--
+
+   procedure FIRST_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS : RTEMS.STATUS_CODES;
+   begin
+
+      TIMER_DRIVER.INITIALIZE;
+
+      RTEMS.TASK_DELETE( RTEMS.SELF, STATUS );
+
+   end FIRST_TASK;
+
+--PAGE
+-- 
+--  MIDDLE_TASKS
+--
+
+   procedure MIDDLE_TASKS (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS : RTEMS.STATUS_CODES;
+   begin
+
+      RTEMS.TASK_DELETE( RTEMS.SELF, STATUS );
+
+   end MIDDLE_TASKS;
+
+--PAGE
+-- 
+--  LAST_TASK
+--
+
+   procedure LAST_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+   begin
+
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "TASK_DELETE (self)", 
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.TASK_DELETE 
+      );
+
+      RTEMS.SHUTDOWN_EXECUTIVE( 0 );
+
+   end LAST_TASK;
+
+end TMTEST;
Index: c/src/ada-tests/tmtests/tm18/tmtest.ads
===================================================================
--- c/src/ada-tests/tmtests/tm18/tmtest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/tmtests/tm18/tmtest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,135 @@
+--
+--  TMTEST / SPECIFICATION
+--
+--  DESCRIPTION:
+--
+--  This package is the specification for Test 18 of the RTEMS
+--  Timing Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  tmtest.ads,v 1.3 1995/07/12 19:43:59 joel Exp
+--
+
+with RTEMS;
+with TIME_TEST_SUPPORT;
+with TIMER_DRIVER;
+
+package TMTEST is
+
+--
+--  The following variable is set to the execution time returned
+--  by the timer.
+--
+
+   END_TIME       : RTEMS.UNSIGNED32;
+
+--
+--  INIT
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task initializes the application.
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  TEST_INIT
+--
+--  DESCRIPTION:
+--
+--  This subprogram performs test initialization.
+--
+
+   procedure TEST_INIT;
+
+--
+--  FIRST_TASK
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task is the first task to execute.  It starts the
+--  timer and performs a TASK_DELETE on itself.
+--
+
+   procedure FIRST_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  MIDDLE_TASK
+--
+--  DESCRIPTION:
+--
+--  These RTEMS tasks perform a TASK_DELETE on themselves.
+--
+
+   procedure MIDDLE_TASKS (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  LAST_TASK
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task is the last task to execute.  It stops the
+--  timer and reports the execution time of a TASK_DELETE SELF.
+--
+
+   procedure LAST_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  This is the Initialization Tasks Table for this test.
+--
+
+   INITIALIZATION_TASKS : aliased RTEMS.INITIALIZATION_TASKS_TABLE( 1 .. 1 ) := 
+   (1=>
+     (
+       RTEMS.BUILD_NAME( 'U', 'I', '1', ' ' ),        -- task name
+       2048,                                          -- stack size
+       1,                                             -- priority
+       RTEMS.DEFAULT_ATTRIBUTES,                      -- attributes
+       TMTEST.INIT'ACCESS,                            -- entry point
+       RTEMS.NO_PREEMPT,                              -- initial mode
+       0                                              -- argument list
+     )
+   );
+
+--
+--  This is the Configuration Table for this test.
+--
+
+   CONFIGURATION : aliased RTEMS.CONFIGURATION_TABLE := (
+      RTEMS.NULL_ADDRESS,        -- will be replaced by BSP
+      256 * 1024,                -- executive RAM size
+      111,                       -- maximum # tasks
+      0,                         -- maximum # timers
+      0,                         -- maximum # semaphores
+      1,                         -- maximum # message queues
+      100,                       -- maximum # messages
+      0,                         -- maximum # partitions
+      0,                         -- maximum # regions
+      0,                         -- maximum # dp memory areas
+      0,                         -- maximum # periods
+      0,                         -- maximum # user extensions
+      RTEMS.MILLISECONDS_TO_MICROSECONDS(10), -- # us in a tick
+      0                          -- # ticks in a timeslice
+  );
+
+end TMTEST;
